% Los programas son para fines educativo y se ofrecen para uso publico 
% en educacin
% Dr. Carlos Barrn Romero
% Septiembre de 2019
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Programa para ejecutar un AFD
global tam_Tb
global Tb_qe
global Tb_s
global Tb_qs
global Tb_ef
% Tam:tb Tamao de la tabla de la funcin de transicin
% Variables tipo arreglo de la funcin de transicin
% Tb_qe: estado de entrada
% Tb_s:  smbolo de entrada
% Tb_qs: estado de salida
% Tb_ef: indicador de estado de salida (1: s), (0: no)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tam_Tb=0;
Tb_qe=0;
Tb_s='';
Tb_qs=0;
Tb_ef=0;

% Tb_funTran.txt: Archivo de la tabla de la funcin de transicin
% Numero \tab simbolo \tab Numero \tab_numero.

[file_tb,path1] = uigetfile('Tb_2funTran.txt');
fileID = fopen(file_tb,'r');
% Construye una tabla de estructura qe;numero,s:simbol,
% qs:numero, st_q: numero (1: si es de salida, 0: no es de salida)
while(~feof(fileID))
    tline = fgetl(fileID);
    tam_Tb = tam_Tb + 1;
    d_tmp = sscanf(tline,"%d\t%c\t%d\t%d");
    % Tb_qe(i) : estado de entrada
    % Tb_s(i)  : smbolo de entrada
    % Tb_qs(i) : estado de salida
    % Tb_ef(i) : indica estado final
    Tb_qe(tam_Tb)=d_tmp(1);
    Tb_s(tam_Tb) =d_tmp(2);
    Tb_qs(tam_Tb)=d_tmp(3);
    Tb_ef(tam_Tb)=d_tmp(4);
end
fclose(fileID);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

while(1)
    cadena=input('dar una cadena (T: terminar) => ','s');
    if (cadena=='T')
        break;
    end
    qa=0; % 0 es el estado inicial
    % analiza la cadena 
    for j=1:length(cadena)
        [qr, st_q]=f2_automataFD(qa,cadena(j:j));
        if (qr==-1)
            break; % Termina porque no hay transicin valida
        else
            qa=qr; % actualiza el estado del AFD
        end
    end
    if (qr~=-1)&(st_q==1) % es estado final?
        disp('Cadena aceptada');
    else
        disp('Cadena rechazada');
    end
end
